'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PermissionDeniedError = exports.ObjectIsNotExistError = exports.ParameterIsIncorrectError = undefined;

var _ErrorCodes = require('./ErrorCodes');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ParameterIsIncorrectError = exports.ParameterIsIncorrectError = function (_Error) {
  _inherits(ParameterIsIncorrectError, _Error);

  function ParameterIsIncorrectError() {
    var message = arguments.length <= 0 || arguments[0] === undefined ? '参数格式错误' : arguments[0];

    _classCallCheck(this, ParameterIsIncorrectError);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ParameterIsIncorrectError).call(this, message));

    _this.code = _ErrorCodes.kParamsIsIncorrectErrorCode;
    return _this;
  }

  return ParameterIsIncorrectError;
}(Error);

var ObjectIsNotExistError = exports.ObjectIsNotExistError = function (_Error2) {
  _inherits(ObjectIsNotExistError, _Error2);

  function ObjectIsNotExistError() {
    var message = arguments.length <= 0 || arguments[0] === undefined ? '找不到该对象' : arguments[0];

    _classCallCheck(this, ObjectIsNotExistError);

    var _this2 = _possibleConstructorReturn(this, Object.getPrototypeOf(ObjectIsNotExistError).call(this, message));

    _this2.code = _ErrorCodes.kObjectIsNotExistErrorCode;
    return _this2;
  }

  return ObjectIsNotExistError;
}(Error);

var PermissionDeniedError = exports.PermissionDeniedError = function (_Error3) {
  _inherits(PermissionDeniedError, _Error3);

  function PermissionDeniedError() {
    var message = arguments.length <= 0 || arguments[0] === undefined ? '没有权限访问' : arguments[0];

    _classCallCheck(this, PermissionDeniedError);

    var _this3 = _possibleConstructorReturn(this, Object.getPrototypeOf(PermissionDeniedError).call(this, message));

    _this3.code = _ErrorCodes.kPermissionDeniedErrorCode;
    return _this3;
  }

  return PermissionDeniedError;
}(Error);