'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('ibe-utils:' + __filename.split('/').slice(-3).join('/'));

function Tracker(_ref, res) {
  var category = _ref.category;
  var action = _ref.action;
  var label = _ref.label;
  var value = _ref.value;

  if (!(this instanceof Tracker)) {
    return new Tracker({ category: category, action: action, label: label, value: value }, res);
  }

  var cid = process.env.IBE_SYSTEM || '555';

  this.data = {
    v: '1', // API Version.
    tid: 'UA-77841226-1', // Tracking ID / Property ID.
    cid: cid,
    t: 'event', // Event hit type.
    ec: category, // Event category.
    ea: action, // Event action.
    el: label, // Event label.
    ev: value };
}

// Event value.
Tracker.prototype = {
  send: function send() {
    var cb = arguments.length <= 0 || arguments[0] === undefined ? function () {} : arguments[0];

    _request2.default.post('http://www.google-analytics.com/collect', {
      form: this.data
    }, function (err, response, body) {
      if (err) {
        return cb(err);
      }
      if (response.statusCode !== 200) {
        return cb(new Error('Tracking failed'));
      }
      debug('tracker success');
      cb();
    });
  }
};

exports.default = Tracker;