'use strict';

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('ibe-utils:config');

var env = process.env.LEANCLOUD_APP_ENV || process.env.NODE_ENV || 'development';

var specific = {
  // 本地开发环境
  development: {
    env: 'development',
    app: {
      REDIS_URL: 'redis://127.0.0.1:6379',
      domain: '.ibetterme.net',
      home: 'http://ibetterme.net/',
      home_rpc_url: 'https://ibetterme.net/rpc/'
    },
    url: {
      ibeHome: 'http://ibetterme.net/'
    }
  },
  // 本地开发环境
  test: {
    env: 'test',
    app: {
      env: env,
      REDIS_URL: 'redis://127.0.0.1:6379',
      name: 'iBetterMe - Dev',
      domain: '.ibetterme.net',
      home: 'https://ibetterme.net/',
      home_rpc_url: 'https://ibetterme.net/rpc/'
    },
    url: {
      ibeHome: 'http://ibetterme.net/'
    }
  },
  // 预发布环境
  stage: {
    env: 'stage',
    app: {
      env: env,
      name: 'iBetterMe - 预发布',
      domain: '.stg-ibetterme.leanapp.cn',
      home: 'https://stg-ibetterme.leanapp.cn/',
      home_rpc_url: 'https://ibetterme.net/rpc/',
      REDIS_URL: process.env.REDIS_URL_ibetterme_redis_1
    },
    url: {
      ibeHome: 'https://stg-ibetterme.leanapp.cn/'
    }
  },
  // 线上环境
  production: {
    env: 'production',
    app: {
      env: env,
      port: process.env.LEANCLOUD_APP_PORT,
      name: 'iBetterMe',
      domain: '.ibetterme.com',
      home: 'https://ibetterme.com/',
      home_rpc_url: 'https://ibetterme.com/rpc/',
      REDIS_URL: process.env.REDIS_URL_ibetterme_redis_1
    },
    url: {
      ibeHome: 'https://ibetterme.com/'
    }
  }
};
debug('env:', env);
module.exports = specific[env];