'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = checkCurrentUserInfo;

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _constants = require('../constants');

var _base64_decode = require('../base64_decode');

var _base64_decode2 = _interopRequireDefault(_base64_decode);

var _UserInfo = require('../models/UserInfo');

var UserInfo = _interopRequireWildcard(_UserInfo);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('ibe-utils:' + __filename.split('/').slice(-3).join('/'));
function checkCurrentUserInfo(req, res, next) {
  debug('1. 登录状态校验');
  var userInfoCookie = req.signedCookies[_constants.kSessionUserInfoKey];
  var userId = null;
  debug('userInfoCookie:', userInfoCookie);
  if (userInfoCookie) {
    var json = {};
    try {
      json = JSON.parse((0, _base64_decode2.default)(userInfoCookie));
      debug('json:', json);
      userId = json.objectId;
    } catch (e) {
      return next(e);
    }
  }

  if (userId) {
    debug('1.1 登录状态正常', userId);

    (0, _co2.default)(function* () {
      res.locals.currentUserInfo = yield UserInfo.fetchUserInfoWithUserId(userId);
      next();
    }).catch(next);
  } else {
    res.locals.currentUserInfo = null;
    next();
  }
};