'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (req, res, next) {
  var _req$query = req.query;
  var signature = _req$query.signature;
  var nonce = _req$query.nonce;
  var timestamp = _req$query.timestamp;


  if (!signature) {
    signature = req.body.signature;
    nonce = req.body.signature;
    timestamp = req.body.signature;
  }

  if ((0, _signature.checkSignature)({ signature: signature, nonce: nonce, timestamp: timestamp })) {
    return next();
  }
  return res.json({
    success: false,
    message: 'signature error'
  });
};

var _signature = require('../signature');

var debug = require('debug')('ibe-utils:' + __filename.split('/').slice(-3).join('/'));