'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = loginRequired;

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _constants = require('../constants');

var _base64_decode = require('../base64_decode');

var _base64_decode2 = _interopRequireDefault(_base64_decode);

var _UserInfo = require('../models/UserInfo');

var UserInfo = _interopRequireWildcard(_UserInfo);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('ibe-utils:' + __filename.split('/').slice(-3).join('/'));
function loginRequired(req, res, next) {
  debug('1. 登录状态校验');

  var userInfoCookie = req.signedCookies[_constants.kSessionUserInfoKey];
  debug('userInfoCookie:', req.signedCookies);
  debug('cookes:', req.cookies);
  var userId = null;
  if (userInfoCookie) {
    var json = {};
    try {
      json = JSON.parse((0, _base64_decode2.default)(userInfoCookie));
      debug('json:', json);
      userId = json.objectId;
    } catch (e) {
      return next(e);
    }
  }
  debug('userId', userId);

  if (userId) {
    debug('1.1 登录状态正常', userId);

    (0, _co2.default)(function* () {
      res.locals.currentUserInfo = yield UserInfo.fetchUserInfoWithUserId(userId);
      next();
    }).catch(next);
  } else {
    var _ret = function () {
      debug('2.准备登录');
      var backURI = _url2.default.format({
        protocol: req.protocol,
        host: req.get('host'),
        pathname: req.originalUrl
      });
      var loginURI = _url2.default.resolve(_config2.default.app.home, '/passport/login/?back=' + encodeURIComponent(backURI));
      return {
        v: res.format({
          'html': function html() {
            if (!res.locals.isWeixin) {
              debug('2.1 网页登录,直接跳转到登录页面');
              return res.redirect(loginURI);
            }
            debug('2.2 微信登录,跳转到微信授权登录页面');
            // 微信登录

            res.redirect(_url2.default.resolve(_config2.default.app.home, '/passport/goto_weixin_login?back=' + encodeURIComponent(backURI)));
          },
          'default': function _default() {
            res.json({
              success: false,
              message: '权限不足',
              redirect: loginURI
            });
          }
        })
      };
    }();

    if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
  }
};