'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = paginate;
var debug = require('debug')('iBetterMe:server:middleware:paginate');
function paginate(req, res, next) {
  var page = +(req.query.page || 1);
  // 判断是否是数字
  if (isNaN(page)) {
    page = 1;
  }
  // 不能小于1
  if (page < 1) {
    page = 1;
  }
  res.locals.page = page;

  var limit = +(req.query.limit || 20);
  if (isNaN(limit)) {
    limit = 20;
  }
  // 不能小于 1, 并且也不能太大
  if (limit < 1 || limit > 50) {
    limit = 20;
  }

  res.locals.limit = limit;

  debug('res.locals.limit:', res.locals.limit, 'res.locals.page:', res.locals.page);
  next();
}