'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetchWeixinMPInfoForSystemProps = fetchWeixinMPInfoForSystemProps;

var _client = require('../redis/client');

var _client2 = _interopRequireDefault(_client);

var _kRedisKeys = require('../redis/kRedisKeys');

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('ibe-utils:' + __filename.split('/').slice(-3).join('/'));
function fetchWeixinMPInfoForSystemProps(req, res, next) {
  // 如果是微信,那么获取微信相关信息
  if (!res.locals.isWeixin) {
    return next();
  }
  var url = void 0;
  if (req.query.ref) {
    url = decodeURIComponent(req.query.ref);
  } else {
    url = req.protocol + '://' + req.hostname + req.originalUrl.slice(1);
  }
  debug('url', url);
  (0, _co2.default)(function* () {

    var configStr = yield _client2.default.get(_kRedisKeys.kRedisKeySystemConfig);
    var systemConfig = JSON.parse(configStr);

    var config = {
      nonceStr: "Wm3WZYTPz0wzccnW",
      timestamp: parseInt(+new Date() / 1000).toString(),
      url: url,
      jsapi_ticket: systemConfig.weixinMPInfo.jsapiTicket
    };
    debug('config:', config);

    var array = Object.keys(config).sort(function (a, b) {
      return a > b;
    }).map(function (key) {
      return key.toLowerCase() + '=' + config[key];
    });
    var string1 = array.join('&');
    var shasum = crypto.createHash('sha1');
    var signature = shasum.update(string1).digest('hex');

    var result = {
      appId: systemConfig.weixinMPInfo.appId,
      timestamp: config.timestamp,
      nonceStr: config.nonceStr,
      signature: signature
    };
    debug('string1:', string1);
    debug('fetchWeixinJsapiConfigForUrl:', Object.assign({}, config, result));

    var system = Object.assign({}, res.locals.props.system, {
      weixinmp: Object.assign({}, config, result)
    });
    Object.assign(res.locals.props, { system: system });
    next();
  }).catch(next);
}