'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.requestIdentifierWithTarget = requestIdentifierWithTarget;
exports.requestIdentifierWithTargetURI = requestIdentifierWithTargetURI;

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _co = require('co');

var _co2 = _interopRequireDefault(_co);

var _fetchDataFromRpc = require('../rpc/fetchDataFromRpc');

var _fetchDataFromRpc2 = _interopRequireDefault(_fetchDataFromRpc);

var _client = require('../redis/client');

var _client2 = _interopRequireDefault(_client);

var _kRedisKeys = require('../redis/kRedisKeys');

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _ = require('../');

var constants = _interopRequireWildcard(_);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('ibe-utils:' + __filename.split('/').slice(-3).join('/'));

function* requestIdentifierWithTarget() {
  var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

  var
  // 必填
  objectId = _ref.objectId;
  var _ref$__type = _ref.__type;

  var __type = _ref$__type === undefined ? 'RemotePointer' : _ref$__type;

  var _ref$className = _ref.className;
  var className = _ref$className === undefined ? '' : _ref$className;
  var authorId = arguments[1];
  var contentTypes = arguments.length <= 2 || arguments[2] === undefined ? [constants.kCommentContentTypeText] : arguments[2];

  var system = process.env.IBE_SYSTEM;

  var url = _config2.default.url.ibeComment + 'rpc/v1.0/comment/request/identifier.json';

  var _ref2 = yield (0, _fetchDataFromRpc2.default)(url, {
    authorId: authorId,
    target: {
      objectId: objectId, __type: __type, className: className, system: system
    },
    contentTypes: contentTypes
  }, 'PUT');

  var identifier = _ref2.identifier;


  return Promise.resolve(identifier);
}

function* requestIdentifierWithTargetURI(targetURI, authorId) {
  var contentTypes = arguments.length <= 2 || arguments[2] === undefined ? [constants.kCommentContentTypeText] : arguments[2];

  var url = _config2.default.url.ibeComment + 'rpc/v1.0/comment/request/identifier.json';

  var _ref3 = yield (0, _fetchDataFromRpc2.default)(url, {
    authorId: authorId,
    targetURI: targetURI,
    contentTypes: contentTypes
  }, 'PUT');

  var identifier = _ref3.identifier;


  return Promise.resolve(identifier);
}