'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = fetchDataFromHomeRpc;

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _signature = require('../signature');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('ibe-utils:' + __filename.split('/').slice(-3).join('/'));
function* fetchDataFromHomeRpc(path) {
  var qs = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var signature = yield (0, _signature.createSignature)();
  return new Promise(function (resolve, reject) {
    var url = _url2.default.resolve(_config2.default.app.home_rpc_url, path);
    _request2.default.get({
      url: url,
      qs: _extends({}, signature, qs),
      json: true
    }, function (error, response, body) {
      debug('L20:body:', body);
      if (error) {
        return reject(error);
      }
      debug('ibe-utils:', body);
      if (body.success === false) {
        debug('reject:body:', body);
        return reject(new Error(body.message));
      }
      resolve(body.data);
    });
  });
}