'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = fetchDataFromRpc;

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _config = require('../config');

var _config2 = _interopRequireDefault(_config);

var _signature = require('../signature');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var debug = require('debug')('ibe-utils:' + __filename.split('/').slice(-3).join('/'));
function* fetchDataFromRpc(url) {
  var data = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];
  var method = arguments.length <= 2 || arguments[2] === undefined ? 'GET' : arguments[2];

  var signature = yield (0, _signature.createSignature)();
  var options = _extends({}, signature);
  if (method.toLowerCase() === 'get') {
    options['qs'] = data;
  } else {
    options['body'] = data;
  }

  return new Promise(function (resolve, reject) {
    (0, _request2.default)(_extends({
      method: method,
      url: url,
      json: true
    }, options), function (error, response, body) {
      if (error) {
        console.error('rpc :' + url + ': error:', error);
        return reject(error);
      }
      if (body.success) {
        resolve(body.payload);
        console.log('rpc :' + url + ': success');
      } else {
        reject(new Error(body.message));
        console.error('rpc error:', body);
      }
    });
  });
}